/////////////////////////////////////////////////////////////////////////////
// RhinoRectangleUserDataObject.h
//

#pragma once

////////////////////////////////////////////////////////////////////////////////////////
// CRhinoRectangleUserDataObject
//
class CRhinoRectangleUserDataObject : public CRhinoCurveObject
{
  ON_OBJECT_DECLARE( CRhinoRectangleUserDataObject );

public:
  CRhinoRectangleUserDataObject();                                        // assigns a new object UUID
  CRhinoRectangleUserDataObject(const ON_3dmObjectAttributes&);           // assigns a new object UUID
  CRhinoRectangleUserDataObject( const CRhinoRectangleUserDataObject& );          // copies source object UUID
  CRhinoRectangleUserDataObject& operator=(const CRhinoRectangleUserDataObject&); // copies source object UUID
  ~CRhinoRectangleUserDataObject();

  //Description:
  //  virtual CRhinoObject::ShortDescription override
  //Returns:
  //  "rectangle objects" or "rectangle object"
  const wchar_t* ShortDescription( bool bPlural ) const;

  // virtual CRhinoObject::EnableGrips override
  void EnableGrips( bool bGripsOn );

  // Description:
  //   Specify the rectangle geometry.
  // Parameters:
  //   curve - [in] curve geometry copied to object
  // Returns:
  //   Pointer to curve geometry on CRhinoRectangleUserDataObject.
  ON_Curve* SetCurve( const ON_PolylineCurve& curve );

  // Description:
  //   Specify the rectangle geometry.
  // Parameters:
  //   pCurve - [in] ~CRhinoRectangleUserDataObject() will delete this curve
  void SetCurve( ON_PolylineCurve* pCurve );

  const ON_PolylineCurve* Curve() const;
};
