/////////////////////////////////////////////////////////////////////////////
// cmdSampleCustomGripsUserData.cpp : command file
//

#include "StdAfx.h"
#include "SampleCustomGripsUserDataPlugIn.h"
#include "SampleObjectUserData.h"
#include "RhinoRectangleUserDataObject.h"

////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////
//
// BEGIN SampleCustomGripsUserData command
//

#pragma region SampleCustomGripsUserData command


// Do NOT put the definition of class CCommandSampleCustomGripsUserData in a header
// file.  There is only ONE instance of a CCommandSampleCustomGripsUserData class
// and that instance is the static theSampleCustomGripsUserDataCommand that appears
// immediately below the class definition.

class CCommandSampleCustomGripsUserData : public CRhinoCommand
{
public:
  // The one and only instance of CCommandSampleCustomGripsUserData is created below.
  // No copy constructor or operator= is required.  Values of
  // member variables persist for the duration of the application.

  // CCommandSampleCustomGripsUserData::CCommandSampleCustomGripsUserData()
  // is called exactly once when static theSampleCustomGripsUserDataCommand is created.
	CCommandSampleCustomGripsUserData() {}

  // CCommandSampleCustomGripsUserData::~CCommandSampleCustomGripsUserData()
  // is called exactly once when static theSampleCustomGripsUserDataCommand is
  // destroyed.  The destructor should not make any calls to
  // the Rhino SDK.  If your command has persistent settings,
  // then override CRhinoCommand::SaveProfile and CRhinoCommand::LoadProfile.
  ~CCommandSampleCustomGripsUserData() {}

  // Returns a unique UUID for this command.
  // If you try to use an id that is already being used, then
  // your command will not work.  Use GUIDGEN.EXE to make unique UUID.
	UUID CommandUUID()
	{
		// {25C4F300-1A1E-4C1D-986D-EFAB5A38D0A7}
    static const GUID SampleCustomGripsUserDataCommand_UUID =
    { 0x25C4F300, 0x1A1E, 0x4C1D, { 0x98, 0x6D, 0xEF, 0xAB, 0x5A, 0x38, 0xD0, 0xA7 } };
    return SampleCustomGripsUserDataCommand_UUID;
	}

  // Returns the English command name.
	const wchar_t* EnglishCommandName() { return L"SampleCustomGripsUserData"; }

  // Returns the localized command name.
	const wchar_t* LocalCommandName() const { return L"SampleCustomGripsUserData"; }

  // Rhino calls RunCommand to run the command.
	CRhinoCommand::result RunCommand( const CRhinoCommandContext& );
};

// The one and only CCommandSampleCustomGripsUserData object.  
// Do NOT create any other instance of a CCommandSampleCustomGripsUserData class.
static class CCommandSampleCustomGripsUserData theSampleCustomGripsUserDataCommand;

CRhinoCommand::result CCommandSampleCustomGripsUserData::RunCommand( const CRhinoCommandContext& context )
{
  ON_3dPoint rect[5];
  
  CArgsRhinoGetPlane args;
  args.SetCornerMode( CArgsRhinoGetPlane::mode_corners );
  args.SetAllowRounded( FALSE );
  args.SetAllowDeformable( FALSE );
 
  CRhinoCommand::result rc = RhinoGetRectangle( args, rect );
  
  if( rc == CRhinoCommand::success)
  {
    ON_Polyline pline;
    rect[4] = rect[0];
    pline.Create( 3, FALSE, 5, 3, (double*)&rect );

    ON_PolylineCurve* pline_curve = new ON_PolylineCurve( pline );
    
    CRhinoRectangleUserDataObject* rect_object = new CRhinoRectangleUserDataObject();
    rect_object->SetCurve( pline_curve );

	CRhinoGetPoint gp;
	gp.SetCommandPrompt( L"Pick point" );
	gp.GetPoint();
	if( gp.CommandResult() != success )
	return gp.CommandResult();

	CRhinoGetString gs;
	gp.SetCommandPrompt( L"Description" );
	gs.GetString();
	if( gs.CommandResult() != success )
	return gs.CommandResult();

	bool rc = CSampleObjectUserData::AddSampleObjectUserData( context.m_doc, rect_object, gp.Point(), gs.String() );
	RhinoApp().Print( L"%s\n", rc ? L"Succeeded!" : L"Failed!" );

	context.m_doc.Redraw();
  }

  return CRhinoCommand::success;
}

#pragma endregion

//
// END SampleCustomGripsUserData command
//
////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////
